MSK3Parser Class Reference

the main class to read a Microsoft Works file More...

`#include <MSK3Parser.hxx>`

Inheritance diagram for MSK3Parser:

## Public Member Functions

| MSK3Parser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor More...
virtual | ~MSK3Parser ()
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false)
| checks if the document header is correct (or not) More...
void | parse (WPXDocumentInterface *documentInterface)
| virtual function used to parse the input More...
Public Member Functions inherited from MSKParser
| MSKParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor More...
| MSKParser (MWAWInputStreamPtr input, MWAWParserStatePtr parserState)
| constructor using the parser state More...
virtual | ~MSKParser ()
| destructor More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
bool | getColor (int id, MWAWColor &col, int vers=-1) const
| return the color which correspond to an index More...
virtual void | sendFrameText (MWAWEntry const &entry, std::string const &frame)
| virtual function used to send the text of a frame (v4) More...
virtual void | sendOLE (int id, MWAWPosition const &pos, WPXPropertyList frameExtras)
| virtual function used to send an OLE (v4) More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
void | setVersion (int vers)
| sets the works version More...

## Protected Member Functions

void | init ()
| inits all internal variables More...
void | createDocument (WPXDocumentInterface *documentInterface)
| creates the listener which will be associated to the document More...
bool | createZones ()
| finds the different objects zones More...
double | getTextHeight () const
| returns the page height, ie. paper size less margin (in inches) less header/footer size More...
Vec2f | getPageLeftTop () const
| returns the page top left point More...
void | newPage (int number, bool softBreak=false)
| adds a new page More...
bool | readZone (MSK3ParserInternal::Zone &zone)
| try to read a generic zone More...
bool | readDocumentInfo ()
| try to read the documentinfo ( zone2) More...
bool | readGroup (MSK3ParserInternal::Zone &zone, MWAWEntry &entry, int check)
| try to read a group zone (zone3) More...
bool | readGroupHeaderInfo (bool header, int check)
| try to read a zone information (zone0) More...
bool | sendFootNote (int zoneId, int noteId)
| try to send a note More...
void | sendText (int id, int noteId=-1)
| try to send a text entry More...
void | sendZone (int zoneType)
| try to send a zone More...
bool | readPrintInfo ()
| read the print info zone More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr state)
| constructor using a state More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWContentListenerPtr & | getListener ()
| returns the listener More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
void | setListener (MWAWContentListenerPtr &listener)
| sets the listener More...
void | resetListener ()
| resets the listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
void | setFontConverter (MWAWFontConverterPtr fontConverter)
| sets the font convertor More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes

shared_ptr < MSK3ParserInternal::State > | m_state
| the state More...
std::vector< MWAWEntry > | m_listZones
| the list of different Zones More...
shared_ptr< MSKGraph > | m_graphParser
| the graph parser More...
shared_ptr< MSK3Text > | m_textParser
| the text parser More...
Protected Attributes inherited from MSKParser
shared_ptr < MSKParserInternal::State > | m_state
| the state More...
MWAWInputStreamPtr | m_input
| the input which can be an OLE in MSWorks 4 file More...
libmwaw::DebugFile | m_asciiFile
| the debug file of the actual input More...

## Friends

class | MSK3ParserInternal::SubDocument
class | MSKGraph
class | MSK3Text

## Additional Inherited Members

Static Public Member Functions inherited from MSKParser
static std::vector< MWAWColor > const & | getPalette (int vers)
| return a list of color corresponding to a version More...

## Detailed Description

the main class to read a Microsoft Works file

## Constructor & Destructor Documentation

MSK3Parser::MSK3Parser | ( | MWAWInputStreamPtr | input,
|  | MWAWRSRCParserPtr | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

MSK3Parser::~MSK3Parser | ( |  | ) |

virtual

destructor

## Member Function Documentation

bool MSK3Parser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |

virtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

void MSK3Parser::createDocument | ( | WPXDocumentInterface * | documentInterface | ) |

protected

creates the listener which will be associated to the document

Referenced by parse().

bool MSK3Parser::createZones | ( |  | ) |

protected

finds the different objects zones

Referenced by parse().

Vec2f MSK3Parser::getPageLeftTop | ( |  | ) | const

protected virtual

returns the page top left point

Implements MSKParser.

double MSK3Parser::getTextHeight | ( |  | ) | const

protected

returns the page height, ie. paper size less margin (in inches) less header/footer size

Referenced by MSK3Text::update().

void MSK3Parser::init | ( |  | ) |

protected

inits all internal variables

Referenced by MSK3Parser().

void MSK3Parser::newPage | ( | int | number,
|  | bool | softBreak = `false`
| ) |  |

protected

adds a new page

Referenced by MSK3Text::send().

void MSK3Parser::parse | ( | WPXDocumentInterface * | documentInterface | ) |

virtual

virtual function used to parse the input

Implements MWAWParser.

bool MSK3Parser::readDocumentInfo | ( |  | ) |

protected

try to read the documentinfo ( zone2)

Referenced by readZone().

bool MSK3Parser::readGroup | ( | MSK3ParserInternal::Zone & | zone,
|  | MWAWEntry & | entry,
|  | int | check
| ) |  |

protected

try to read a group zone (zone3)

Referenced by readZone().

bool MSK3Parser::readGroupHeaderInfo | ( | bool | header,
|  | int | check
| ) |  |

protected

try to read a zone information (zone0)

Referenced by createZones().

bool MSK3Parser::readPrintInfo | ( |  | ) |

protected

read the print info zone

Referenced by readDocumentInfo().

bool MSK3Parser::readZone | ( | MSK3ParserInternal::Zone & | zone | ) |

protected

try to read a generic zone

Referenced by createZones(), and readGroupHeaderInfo().

bool MSK3Parser::sendFootNote | ( | int | zoneId,
|  | int | noteId
| ) |  |

protected

try to send a note

Referenced by MSK3Text::sendText().

void MSK3Parser::sendText | ( | int | id,
|  | int | noteId = `-1`
| ) |  |

protected

try to send a text entry

Referenced by MSK3ParserInternal::SubDocument::parse().

void MSK3Parser::sendZone | ( | int | zoneType | ) |

protected

try to send a zone

Referenced by parse(), and MSK3ParserInternal::SubDocument::parse().

## Friends And Related Function Documentation

friend class MSK3ParserInternal::SubDocument

friend

friend class MSK3Text

friend

Referenced by init().

friend class MSKGraph

friend

Referenced by init().

## Member Data Documentation

shared_ptr<MSKGraph> MSK3Parser::m_graphParser

protected

the graph parser

Referenced by createDocument(), createZones(), init(), parse(), readGroup(), readZone(), and sendZone().

std::vector<MWAWEntry> MSK3Parser::m_listZones

protected

the list of different Zones

Referenced by checkHeader().

shared_ptr<MSK3ParserInternal::State> MSK3Parser::m_state

protected

the state

Referenced by checkHeader(), createDocument(), createZones(), getPageLeftTop(), getTextHeight(), init(), newPage(), readGroup(), readGroupHeaderInfo(), and sendZone().

shared_ptr<MSK3Text> MSK3Parser::m_textParser

protected

the text parser

Referenced by createDocument(), createZones(), init(), parse(), readDocumentInfo(), readGroupHeaderInfo(), sendText(), and sendZone().

The documentation for this class was generated from the following files:

- MSK3Parser.hxx
- MSK3Parser.cxx